/*
..: The
    _____ _   _  _____    ____  __ _ _   _ _ _______ _    _ _ _   _  _____ 
   / ____| \ | |/ ____|  / /  \/  (_) \ | (_)__   __| |  | (_) \ | |/ ____|
  | |    |  \| | (___   / /| \  / |_|  \| |_   | |  | |__| |_|  \| | (___  
  | |    | . ` |\___ \ / / | |\/| | | . ` | |  | |  |  __  | | . ` |\___ \ 
  | |____| |\  |____) / /  | |  | | | |\  | |  | |  | |  | | | |\  |____) |
   \_____|_| \_|_____/_/   |_|  |_|_|_| \_|_|  |_|  |_|  |_|_|_| \_|_____/ 
                                                                         
                                                                     CReW :.. 
                                presents ...

							OUR DA 3L8 L4M3 SNIFFER =)
*/
/*
** CNSniffer - real & completly libpcap sniffer
** Copyright (C) 2001 CNS <cns@minithins.net>
** http://www.minithins.net
**  $Id: CNSsniff.c,v 1.1 2001/05/26 08:36:00 lkm Exp lkm $
**
**  gcc -O2 -o CNSsniff CNSsniff.c -lpcap -DLOGFILE="\"./logz\"" 
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
 * YOU HAVE TO INSTALL LIBPCAP BEFORE ANY COMPILATION.
 * IF YOU DON'T HAVE LIBPCAP (http://www.tcpdump.org), I M PRETTY SURE
 *  THAT THIS PROGRAM WON'T COMPILE :)
 */

/*
 * Include files. signal.h is used to handle the SIGINT (Ctrl+C)
 */

#include <stdio.h>
#include <pcap.h>
#include <signal.h>
#include <sys/param.h>
#include <fcntl.h>
// added on linux :
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <ctype.h>
#include <stdarg.h>

#include <netinet/in_systm.h>
#ifndef __USE_BSD
#define __USE_BSD
#endif
#include <netinet/in.h>
#include <netinet/ip.h>

#define __FAVOR_BSD
#include <netinet/tcp.h>

#ifndef LOGFILE
#define LOGFILE "./logz"
#endif

/*
 * Personnal notice
 */
#define VERSION "CNSniff, sniffer with libpcap, CNS Powah\n"
#define VERSION2 "cns@minithins.net, http://www.minithins.net/\n"
#define VERSION3 "v0.0.4a (sam jui  7 18:03:25 CEST 2001)\n"

/*
 * Very dirty code :-)
 *
 * Some pcap vars, and getopt vars.
 *
 */
/* Pcap descriptor */
pcap_t *desc;
/* Pcap stat descriptor */
struct pcap_stat *ps;
/* Pcap dumper descriptor */
pcap_dumper_t *logger;
/* arguments for getopt */
extern char *optarg;
extern int optind;
extern int opterr;
/* Number of treated packets */
int trait;
/* Link Header length */
int lhl;
/* ADM ripped: */
/* Ports to log */
u_short ports[] =
{21, 23, 109, 110, 143, 512, 513, 514, 1521, 31337};

struct datalogged {
	u_int32_t ip_src;
	u_int32_t ip_dst;
	u_int16_t th_sport;
	u_int16_t th_dport;
	u_int32_t time;
	u_char data[8192];
	int size;
	};

struct datalogged *fearallofus[8192];
int feargrade = 0;

/* Quiet mode ? */
int quiet, promisc_mode, force;
int mode_read, mode_write, mode_log;
/* Usefull to know what kind of layer 2 support we are listening ... */
typedef struct datalink_type {
        char name[32];
        int  lenght;
        } datalink_data;
/* huh ... */
const datalink_data datalink_main[] = {
        { "no link-layer encapsulation", 4 },
        { "Ethernet (10Mb)", 14 },
        { "Experimental Ethernet (3Mb)", 14 },
        { "Amateur Radio AX.25", 0 },            /* A REMPLIR */
        { "Proteon ProNET Token Ring", 0 },      /* A REMPLIR */
        { "Chaos", 0 },                          /* A REMPLIR */
        { "IEEE 802 Networks", 0 },              /* A REMPLIR */
        { "ARCNET", 0 },                         /* A REMPLIR */
        { "Serial Line IP", 16 },
        { "Point-to-point Protocol", 4 },
        { "FDDI", 21 },
        { "LLC/SNAP encapsulated atm", 0 },      /* A REMPLIR */
        { "raw IP", 0 },
        { "BSD/OS Serial Line IP", 16 },          /* should be ok... */
        { "BSD/OS Point-to-point Protocol", 4 }, /* should be ok... */ 
        { "napu", 0}
        };
/*
 * Returns char* with type of layer 2 support.
 */
char *datalink_name(int datalink_type)
{
char *nom;
nom = (char *)malloc(sizeof(char) * 32);
strcpy(nom, datalink_main[datalink_type].name);
lhl = datalink_main[datalink_type].lenght;
return(nom);
}

int fear_me(u_int32_t ip_src, u_int32_t ip_dst, 
					u_int16_t th_sport, u_int16_t th_dport)
{
int i,j;
j=0;
for(i=0; i < 8192 && j < feargrade+1; i++)
	{
	if (fearallofus[i] != NULL)
		{
		j ++;
		if (fearallofus[i]->ip_src == ip_src 
			&& fearallofus[i]->ip_dst == ip_dst
			&& fearallofus[i]->th_sport == th_sport
			&& fearallofus[i]->th_dport == th_dport)
				return(i);
		}
	}

for(i=0; i < 8192; i++)
	{
	if (fearallofus[i] == NULL)
		{
		fearallofus[i] = (struct datalogged*)malloc(sizeof(struct datalogged));
		fearallofus[i]->ip_src = ip_src;
		fearallofus[i]->ip_dst = ip_dst;
		fearallofus[i]->th_sport = th_sport;
		fearallofus[i]->th_dport = th_dport;
		fearallofus[i]->time = time (NULL);
		fearallofus[i]->size = 0;
		memset(fearallofus[i]->data,0,8192);
		feargrade ++;
		return(i);
		}
	}

return(-1);
}

void get_out(int d)
{
int fd;
char *buffer;
struct in_addr in, in2;
// on log ici
buffer = (char*)malloc(sizeof(char) * 16384);
fd = open(LOGFILE, O_WRONLY | O_APPEND | O_CREAT, 0600);
in.s_addr = fearallofus[d]->ip_src;
in2.s_addr = fearallofus[d]->ip_dst;
sprintf(buffer,"%s:%i -> %s:%i: %s\n",inet_ntoa(in),ntohs(fearallofus[d]->th_sport),
								inet_ntoa(in2),ntohs(fearallofus[d]->th_dport),fearallofus[d]->data);
write(fd,buffer,strlen(buffer));
close (fd);

free (buffer);
// fin du log 

free(fearallofus[d]);
fearallofus[d]= NULL;
feargrade --;
}

void clear_all_dead()
{
int i, j;
int dd;
j=0;
for(i=0; i < 8192 && j < feargrade+1; i++)
    {
    if (fearallofus[i] != NULL)
		{
		j ++;
		if (fearallofus[i]->time + 7000 < time(NULL))
			{
			// Delete 2 connections
			dd = fear_me(fearallofus[i]->ip_dst,
							fearallofus[i]->ip_src,
							fearallofus[i]->th_dport,
							fearallofus[i]->th_sport);
			get_out(i);
			if (dd != -1)
				get_out(dd);
			}
		}
	}
}

/*
 * parse and log
 */
void parse_and_log(u_char *packet, int len)
{
int i, ok, dd, dd2;
u_char *buf = packet, *def;
struct ip *iph = (struct ip *) (buf + lhl);
struct tcphdr *tcph = (struct tcphdr *) (buf + lhl + sizeof(struct ip));

if (len != (lhl + htons(iph->ip_len)))
	return;
/*
// Erreur: non loggu et pis basta
	printf("erreur taille ...(%i %i)\n",len,lhl + htons(iph->ip_len));
else
	printf("taille correcte ...\n");
*/

if (iph->ip_v != 4 || iph->ip_p != 6)
	return; 

// ok .. we have a good tcp packet .. now we 'll check what he says

ok = 0;

for (i=0; ports[i] != 31337; i ++) {
	if (ports[i] == ntohs (tcph->th_sport)
		|| ports[i] == ntohs (tcph->th_dport))
			 ok = 1;
	}

if (!ok) return;	
// pas dans les ports  logguer ...
dd = fear_me(iph->ip_src.s_addr,iph->ip_dst.s_addr,tcph->th_sport,tcph->th_dport);

buf += sizeof (struct ip) + sizeof(struct tcphdr) + lhl;

def=(u_char *)malloc(8192);
memset(def, 0 , 8192);

for (i= 0; i< (len - lhl - sizeof (struct ip)  - sizeof(struct tcphdr));i++)
	{
	if (isprint(buf[i]))
		def[i] = buf[i];
	else
		def[i] = '.';
	}
//printf("taille: %i %i %i\n",dd,strlen(def),strlen(fearallofus[dd]->data));

ok = strlen(fearallofus[dd]->data);
for (i=ok;i<ok+strlen(def);i++)
	fearallofus[dd]->data[i] = def[i-ok];

fearallofus[dd]->data[ok+strlen(def)] = 0;
fearallofus[dd]->time = time(NULL);
fearallofus[dd]->size += strlen(fearallofus[dd]->data);

if ((tcph->th_flags & TH_RST) || (tcph->th_flags & TH_FIN) || fearallofus[dd]->size >= 8000)
	{
	get_out(dd);
	dd2 = fear_me(iph->ip_dst.s_addr,iph->ip_src.s_addr,tcph->th_dport,tcph->th_sport);
	if (dd2 != -1)
		get_out(dd2);
	clear_all_dead();
	}
}

/*
 * If any user send SIGINT (signal 2), then we:
 */
void status(int signal)
{
if (!mode_read)
	pcap_stats(desc,ps);
printf("\n");
if (logger != NULL)
	pcap_dump_close(logger);

pcap_close(desc);
if (!quiet && !mode_read)
	printf("Total: %6i recv, (%i traits) %6i drop\n",
					ps->ps_recv,trait,ps->ps_drop);
if (!quiet && mode_read)
	printf("Total: %6i recv, (%i traits) %6i drop\n",
					trait,trait,0);
if (!quiet)
	printf("End. (signal %d)\n",signal);
exit(0);
}

/*
 * Function from tcpdump (util.c)
 */
char *takerule(register char **argv)
{
        register char **p;
        register u_int len = 0;
        char *buf;
        char *src, *dst;
        p = argv;
        if (*p == 0)
                return 0;
        while (*p)
                len += strlen(*p++) + 1;
        buf = (char *)malloc(len);
        if (buf == NULL)
		{
		perror("malloc");
		printf("it is better to end now.\n");
		exit(2);
		}
        p = argv;
        dst = buf;
        while ((src = *p++) != NULL) {
                while ((*dst++ = *src++) != '\0')
                        ;
                dst[-1] = ' ';
        }
        dst[-1] = '\0';
        return buf;
}

int main(int argn, char **argv)
{
char *device, *file_read, *file_write, *cmd;
u_char *packet;
struct pcap_pkthdr usefull;
struct bpf_program fcode;
bpf_u_int32 localnet, netmask;
int i,j,k,arg,snap;
struct tm *mytime;

struct sigaction myend;
myend.sa_handler = (void*)status;
myend.sa_flags = 0 ;
sigaction(SIGINT,&myend,NULL);

for (i=0;i<8192;i++) fearallofus[i] = NULL;

file_read = NULL;
file_write = NULL;
mode_read = 0; mode_write = 0; snap = 1518; trait = 0; quiet = 0;
mode_log = 0;
promisc_mode = 0;
device = NULL;
//       pcap_t *pcap_open_offline(char *fname, char *ebuf)
//       pcap_dumper_t *pcap_dump_open(pcap_t *p, char *fname)

while ((arg = getopt(argn, argv, "lDhpfqr:w:i:s:")) != EOF)
        {
        switch(arg)
		{
		case 'l':
			mode_log = 1;
		break;
		case 'f':
		force = 1;
		break;
		case 'p':
		promisc_mode = 1;
		break;
		case 'D':
		if (getuid())
		        {
		        printf("You re not root. Then we stop !\n");
		        exit(1);
		        }
		printf("Daemon mode :-)\n");
		quiet = 1;
		if (fork () != 0)
			exit (0);
		if (setsid()==-1)
			perror("setsid");
		else
			for (i=0; i < NOFILE; i++)
				close(i);
		break;
		case 's':
		snap = atoi(optarg);
		printf("Snaplen changed to: %i\n",snap);
		break;
                case 'i': // -i xl0  == pour choisir l'interface sniff<E9>e.
                //if (optarg != NULL)
		device=optarg;
                printf("Interface changed for %s\n",device);
		break;
		case 'r':
		printf("Read file: %s\n",optarg);
		mode_read = 1;
		file_read = optarg;
		break;
		case 'w':
		printf("Write file: %s\n",optarg);
		mode_write = 1;
		file_write = optarg;
		break;
		case 'q':
		quiet = 1;
		break;
		case 'h':
		default:
		printf(VERSION);
		printf(VERSION2);
		printf(VERSION3);
		printf("  -i [interface] - change default interface\n");
		printf("  -r [file] - read a dump file\n");
		printf("  -w [file] - write a dump file\n");
		printf("  -s [snaplen] - choose a snap length\n");
		printf("  -D - push in daemon mode (quiet mode is engaged)\n");
		printf("  -p - force promiscious mode\n");
		printf("  -f - force non r00t check\n");
		printf("  -q - push in quied mode\n");
		printf("  -l - log mod\n");
		printf("  -h - this help\n");
		exit(0);
		break;
		}
	}

if (getuid()&&!force)
        {
        printf("You re not root. Then we stop !\n");
        exit(1);
        }

if (argv[optind] != NULL)
	{
	cmd = takerule(&argv[optind]);
	printf("Rule: [%s]\n",cmd);
	}
else
	cmd = NULL;

if (device == NULL)
	device = pcap_lookupdev(NULL);

printf("device >>> %s\n",device);

if (!mode_read)
	{
if ((desc = pcap_open_live(device, snap, promisc_mode, 1000, NULL))==NULL)
		{
		perror("pcap_open_live");
		exit(1);
		}
	}
else
	desc = pcap_open_offline(file_read, NULL);


i= pcap_snapshot(desc);

if (i != snap)
	printf("Snap length changed: %i --> %i\n",snap,i);

if (desc == NULL)
        {
        perror("pcap_open_live");
        printf("End.\n");
        exit(1);
        }

if (mode_write)
	{
        if((logger = pcap_dump_open(desc,file_write))==NULL)
		{
		perror("Warning: pcap_dump_open");
		printf("No more dump ll be done\n");
		mode_write = 0;
		}	
	}

if (!mode_read)
	printf("Listening on %s, [%s]\n",device,datalink_name(pcap_datalink(desc)));
else
	printf("Reading %s\n",file_read);

//pcap_dumper_t *pcap_dump_open(pcap_t *, const char *);
//void    pcap_dump_close(pcap_dumper_t *);
//void    pcap_dump(u_char *, const struct pcap_pkthdr *, const u_char *);

//        int pcap_compile(pcap_t *p, struct bpf_program *fp,
//               char *str, int optimize, bpf_u_int32 netmask)

if (pcap_lookupnet(device, &localnet, &netmask, NULL)<0)
	perror("pcap_lookupnet");
if (pcap_compile(desc,&fcode,cmd,1,localnet)<0)
	perror("pcap_compile");
if (pcap_setfilter(desc, &fcode) < 0)
	perror("pcap_setfilter");

if (!mode_read)
	{
	ps = (struct pcap_stat*)malloc(sizeof(struct pcap_stat));
	if (pcap_stats(desc,ps))
		perror("pcap_stats");
	}

while (1)
        {
        packet = (u_char *) pcap_next(desc, &usefull);
        if (packet != NULL)
                {
                mytime = localtime(&usefull.ts.tv_sec);
                if(!quiet) 
					printf("%.2d:%.2d:%.2d.%.6i",mytime->tm_hour,
	                	mytime->tm_min, mytime->tm_sec,(int)usefull.ts.tv_usec);
				trait ++; 
		if (mode_log && !mode_read)
			parse_and_log(packet,usefull.caplen);

                // Affichage du paquet.
		if (mode_write)
			pcap_dump((u_char*)logger,&usefull,packet);

		if (!quiet)
			{	
	                printf(", Len: %i (0x%x)\n",usefull.caplen,usefull.caplen);
        	        for (i=0;i<=usefull.caplen/16;i++)
                	        {
                        	if(i*16 != usefull.caplen) 
					printf("0x%.2x  ",i*16);
				k =(((i+1)*16)>usefull.caplen)?usefull.caplen-(i*16):16;
				for (j=0;j<k;j++)
                	                {
                        	        printf("%.2x ",*packet);
                                	packet++;
	                                }
				if (k != 16)
					for (j=k;j<16;j++)
						printf("   ");
			
				printf("  ");
				packet-=k;
				for (j=0;j<k;j++)
					{
					if (*packet>20)
						printf("%c",*packet);
					else
						printf(".");
					packet++;
					}
				if (i*16 != usefull.caplen)
	                        	printf("\n");
        	                }
			printf("\n");
			}
		}
	}	
return (0);
}
